// TJC implementation of procedure module_option_is_psudo_option
package tjc;
import tcl.lang.*;

public class ModuleOptionIsPsudoOptionCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "option");
        }
        setVarScalar(interp, "option", objv[1], compiledLocals, 0);
        { // Invoke: if {$option == "O"} ... else ...
            // Binary operator: $option == "O"
            TclObject tmp0 = getVarScalar(interp, "option", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("O");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_option_is_psudo_option");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    String[] compiledLocalsNames = {
        "option"
    };
} // end class ModuleOptionIsPsudoOptionCmd

