// TJC implementation of procedure module_option_replace_psudo_option
package tjc;
import tcl.lang.*;

public class ModuleOptionReplacePsudoOptionCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "option enabled");
        }
        setVarScalar(interp, "option", objv[1], compiledLocals, 0);
        setVarScalar(interp, "enabled", objv[2], compiledLocals, 1);
        { // Invoke: if {$option == "O"} ... else ...
            // Binary operator: $option == "O"
            TclObject tmp0 = getVarScalar(interp, "option", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("O");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: if {$enabled} ... else ...
                    TclObject tmp4 = getVarScalar(interp, "enabled", compiledLocals, 1);
                    boolean tmp5 = TJC.getBoolean(interp, tmp4);
                    if ( tmp5 ) {
                        { // Invoke: return [...]
                            { // Invoke: list inline-containers 1 inline-controls 1 cache-commands 1 constant-increment 0 cache-variables 1 inline-commands 1 omit-results 1 inline-expr 1
                                TclObject tmp6 = TclList.newInstance();
                                try {
                                    TclList.append(interp, tmp6, const0);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const2);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const3);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const4);
                                    TclList.append(interp, tmp6, const5);
                                    TclList.append(interp, tmp6, const6);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const7);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const8);
                                    TclList.append(interp, tmp6, const1);
                                    TclList.append(interp, tmp6, const9);
                                    TclList.append(interp, tmp6, const1);
                                } catch (TclException ex) {
                                    tmp6.release();
                                    throw ex;
                                }
                                interp.setResult(tmp6);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: return [...]
                            { // Invoke: list inline-containers 0 inline-controls 0 cache-commands 0 constant-increment 1 cache-variables 0 inline-commands 0 omit-results 0 inline-expr 0
                                TclObject tmp7 = TclList.newInstance();
                                try {
                                    TclList.append(interp, tmp7, const0);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const2);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const3);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const4);
                                    TclList.append(interp, tmp7, const1);
                                    TclList.append(interp, tmp7, const6);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const7);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const8);
                                    TclList.append(interp, tmp7, const5);
                                    TclList.append(interp, tmp7, const9);
                                    TclList.append(interp, tmp7, const5);
                                } catch (TclException ex) {
                                    tmp7.release();
                                    throw ex;
                                }
                                interp.setResult(tmp7);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else {
                { // Invoke: error "..."
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: error
                        objv8[0] = const10;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp10 = new StringBuffer(64);
                        sbtmp10.append("unknown psudo option ");
                        sbtmp10.append("\"");
                        tmp9 = getVarScalar(interp, "option", compiledLocals, 0);
                        sbtmp10.append(tmp9.toString());
                        sbtmp10.append("\"");
                        tmp9 = TclString.newInstance(sbtmp10);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_option_replace_psudo_option");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("inline-containers");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("inline-controls");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("cache-commands");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("constant-increment");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("cache-variables");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("inline-commands");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("omit-results");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("inline-expr");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("error");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "option",
        "enabled"
    };
} // end class ModuleOptionReplacePsudoOptionCmd

