
library ieee;
use ieee.std_logic_1164.all;

entity design is
        generic ( width : natural := 4);
        port ( in1 : in std_logic_vector(width-1 downto 0 );
               in2 : in std_logic_vector(width-1 downto 0 );
               clk1 : in std_logic;
               clk2 : in std_logic;
               rst1 : in std_logic;
               rst2 : in std_logic;
           out1: out std_logic_vector(width-1 downto 0 ) );
end;

architecture rtl of design is
begin
	out1 <= in1 and in2;
end;
