// TJC implementation of procedure compileproc_container_catch_handler_novar
package tjc;
import tcl.lang.*;

public class CompileprocContainerCatchHandlerNovarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol is_empty_body");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "is_empty_body", objv[2], compiledLocals, 1);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 1);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_reset_result
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_reset_result
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_reset_result
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv0, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$is_empty_body} ... else ...
            TclObject tmp3 = getVarScalar(interp, "is_empty_body", compiledLocals, 1);
            boolean tmp4 = TJC.getBoolean(interp, tmp3);
            if ( tmp4 ) {
                { // Invoke: append buffer [...] ...
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv7 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv7[0] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv7, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv7, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp6 = interp.getResult();
                        tmp6.preserve();
                        objv5[0] = tmp6;
                        // Arg 3 constant: ...
                        objv5[1] = const3;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv5, compiledLocals, 2);
                    } finally {
                        tmp6 = objv5[0];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append buffer [...] "interp.setResult(" $tmpsymbol ...
                    TclObject[] objv8 = TJC.grabObjv(interp, 4);
                    TclObject tmp9;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv10 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv10[0] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv10, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv10, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp9 = interp.getResult();
                        tmp9.preserve();
                        objv8[0] = tmp9;
                        // Arg 3 constant: "interp.setResult("
                        objv8[1] = const4;
                        // Arg 4 variable: $tmpsymbol
                        tmp9 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                        tmp9.preserve();
                        objv8[2] = tmp9;
                        // Arg 5 constant: ...
                        objv8[3] = const5;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv8, compiledLocals, 2);
                    } finally {
                        tmp9 = objv8[0];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        tmp9 = objv8[2];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 4);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp11 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp11);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_container_catch_handler_novar");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_reset_result");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_indent");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("interp.setResult(TCL.OK);\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("interp.setResult(");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(");\n");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "is_empty_body",
        "buffer"
    };
} // end class CompileprocContainerCatchHandlerNovarCmd

